<?php
/**
 * Table Definition for friend
 */
require_once 'DB/DataObject.php';

class Friend extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'friend';                          // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.friend_id_seq%29 primary_key
    var $createtime;                      // timestamp(8)  default_now%28%29
    var $owner;                           // text(-1)  not_null unique_key multiple_key
    var $with;                            // text(-1)  not_null unique_key multiple_key
    var $relation;                        // text(-1)  not_null default_knows

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Friend',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function relationLabel() {
      $labels = $this->getRelationLabels();
      $label = $labels[$this->relation];
      return(($label=='')?($this->relation):($label));
    }

    function getRelationLabels() {
      return array("knows"=>"Τ礤","friend"=>"ͧã","goodfriend"=>"ɤͧã","net"=>"ͥåͧã","drink"=>"ͧã","hobby"=>"̣ͧã","business"=>"Żط","fan"=>"ե","school"=>"Ʊ/Ʊ","family"=>"²","secret"=>"̩ͧã");
    }
}
?>