<?php
// $Id: Message.php,v 1.1 2004/06/14 14:52:32 mumumu Exp $
/**
 * Table Definition for message
 */
require_once 'DB/DataObject.php';

class Message extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'message';                         // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.message_id_seq%29 primary_key
    var $sender;                          // text(-1)  not_null
    var $receiver;                        // text(-1)  not_null
    var $subject;                         // text(-1)  
    var $body;                            // text(-1)  
    var $sendtime;                        // timestamp(8)  default_now%28%29
    var $gettime;                         // timestamp(8)  
    var $commandid;                       // text(-1)  

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Message',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    // å
    function send() {
      $result = $this->insert();
      if(is_a($result,"DB_Error")) return false;
      return true;
    }

    function senderPerson() {
      return account2person($this->sender);
    }

    function receiverPerson() {
      return account2person($this->receiver);
    }

    function read() {
        if($this->id>0) {
            $this->getdate = 'now';
            $this->update();
        }
    }


}
?>