<?php
/**
 * Table Definition for person
 * @package wawawa
 * @version $Id: Person.php,v 1.3 2004/07/17 19:09:13 masui Exp $
 */

require_once 'DB/DataObject.php';
require_once 'HTML/QuickForm.php';
require_once 'ymlib/ymdbdo.php';

if(!function_exists('PersonForm_checkUnuseMail')) { 

/**
 * ̤ѤΥ᡼륢ɥ쥹å
 */
function PersonForm_checkUnuseMail($mail) {
    $person = new Person();
    $person->mail = $mail;
    $person->enable = 't';
    $person->status = 'OK';
    
    if($person->count()==0) return true;
    return false;
}

}

if ( !class_exists('Person') ) {

class Person extends YMDB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'person';                          // table name
    var $account;                         // text(-1)  not_null primary_key
    var $createtime;                      // timestamp(8)  not_null default_now%28%29
    var $lastlogin;                       // timestamp(8)  not_null default_now%28%29
    var $enable;                          // bool(1)  not_null default_true
    var $mail;                            // text(-1)  not_null unique_key
    var $passwd;                          // text(-1)  not_null
    var $invited_from;                    // text(-1)  
    var $status;                          // text(-1)  default_OK
    var $firstname;                       // text(-1)  
    var $admin_flag;                      // bool(1)  not_null default_false
    var $admin_memo;                      // text(-1)  
    var $surname;                         // text(-1)  
    var $nick;                            // text(-1)  
    var $birthday;                        // text(-1)  
    var $birthplace;                      // text(-1)  
    var $presentaddress;                  // text(-1)  
    var $occupation;                      // text(-1)  
    var $hobby;                           // text(-1)  
    var $comment;                         // text(-1)  
    var $imessenger;                      // text(-1)  
    var $website;                         // text(-1)  
    var $lastwork;                        // text(-1)  
    var $lastbuy;                         // text(-1)  
    var $rss;                             // text(-1)  

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Person',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE
    
    var $_qf_elements = array(
     'account'=>array('text','account','',array('size' => 30, 'maxlength' => 255)),
     'mail'=>array('text','mail','᡼륢ɥ쥹',array('size' => 30, 'maxlength' => 255)),
     'passwd'=>array('password','passwd','ѥ',array('size' => 20, 'maxlength' => 32)),
     'surname'=>array('text', 'surname', '', array('size' => 8, 'maxlength' => 63)),
     'firstname'=>array('text', 'firstname', '̾', array('size' => 10, 'maxlength' => 63)),
     'nick'=>array('text','nick','˥å͡',array('size' => 30, 'maxlength' => 63)),
     'lastlogin'=>array('text','lastlogin','ǽ',array('size' => 30, 'maxlength' => 63)),
     'createtime'=>array('text','createtime','Ͽ',array('size' => 30, 'maxlength' => 63)),
     'lastbuy'=>array('text','lastbuy','Ƕä',array('size' => 30, 'maxlength' => 255)),
     'birthplace'=>array('text','birthplace','п',array('size' => 30, 'maxlength' => 255)),
     'birthday'=>array('text','birthday','ǯ',array('size' => 9, 'maxlength' => 8)),
     'presentaddress'=>array('text','presentaddress','',array('size' => 30, 'maxlength' => 255)),
     'occupation'=>array('text','occupation','',array('size' => 30, 'maxlength' => 255)),
     'hobby'=>array('text','hobby','̣',array('size' => 30, 'maxlength' => 255)),
     'comment'=>array('textarea','comment','',array('cols' => 30, 'rows'=>'5', 'maxlength' => 255)),
     'imessenger'=>array('text','imessenger','IM',array('size' => 30, 'maxlength' => 255)),
     'website'=>array('text','website','',array('size' => 30, 'maxlength' => 255)),
     'lastwork'=>array('text','lastwork','ǶΤŻ',array('size' => 30, 'maxlength' => 255)),
     'rss'=>array('text','rss','RSS',array('size' => 30, 'maxlength' => 255))
    );
    
    var $_qf_required = array(
        'mail'=>'᡼륢ɥ쥹ϤƤ',
        'passwd'=>'ѥɤϤƤ',
        'surname'=>'̾()ϤƤ',
        'firstname'=>'̾(̾)ϤƤ',
        'nick'=>'˥å͡ϤƤ'
    );
	
	/**
	 * 󥹥ȥ饯 - key
	 */
	function Person(){

		$this->keys('account');
		
	}

    function addElementRule_mail(&$form) {
        $form->addRule('mail','᡼륢ɥ쥹ϤƤ','email');
        $form->registerRule('checkMail', 'callback', 'PersonForm_checkUnuseMail');
        $form->addRule('mail','Υ᡼륢ɥ쥹ϤǤ˻ѤƤޤ','checkMail');
    }
    
    function addElementRule_passwd(&$form) {
        $form->addRule('passwd','ѥɤ4ʸʾαѿϤƤ','alphanumeric');
        $form->addRule('passwd','ѥɤ4ʸʾαѿϤƤ','minlength',4);
    }
    
    function addElementRule_birthday(&$form) {
        $form->addRule('birthday','ǯˤϿ򤤤Ƥ','numeric');
    }
    
    function cansee() {
      return true;
    }

    // set keyword for find()
    function setKeyword($str) {
        $keywords = preg_split("/(\s|)+/",$this->escape(strtolower($str)));
        foreach($keywords as $keyword) {
            $this->whereAdd(sprintf("(lower(surname) like '%%%s%%' OR lower(firstname) like '%%%s%%' OR lower(nick) like '%%%s%%' OR lower(mail) like '%%%s%%')",$keyword,$keyword,$keyword,$keyword),'AND');
        }
    }

    function isFriend() {
        $my = getMe();
        $friend = new Friend();
        $friend->owner = $my->account;
        $friend->with = $this->account;
        if($friend->count()>0) return true;
        return false;        
    }

    function isAdmin($mail) {
        $person = mail2person($mail);
        if( $person->admin_flag != 'f' ) {
            return true;
        }
        return false;
    }
}

function mail2person($mail) {

	$person = DB_DataObject::factory('Person');
	$person->mail = $mail;

	if( $person->find() != 1 ) {
        return null;
	}

    $person->fetch();

    return $person;

}

function account2person($account) {
    $person = new Person();
    if($person->get($account)!=1) {
        return null;
    }
    return $person;
}

}

?>
