<?php
//require_once "init.php";
require_once "ymlib/ymlist.php";
require_once 'HTML/QuickForm/Renderer/Default.php';

class AdminListForm extends YMList_DataObject {
    var $fields = array();
    var $pkey = "KEYFIELD";
    var $table = "tablename";
    var $title;
    var $keyword;
    
    function initialize() {
        $this->script_name = 'admin.php';
    }
    
    function &getDataObject() {
        return PEAR::raiseError("please implement *::getDataObject()");
    }
    
    function getContents() {
        if($this->title=='') {
            $this->title = $this->table.' maintenance';
            if($this->keyword!='') {
                $this->title .= sprintf(' [:%s]',htmlspecialchars($this->keyword));
            }
        }
        $contents = sprintf('<h2 class="function">%s</h2>',$this->title);

        $contents .= '<div align="center">';

        $form = new HTML_QuickForm('searchForm');
        $form->addElement('hidden','table',$this->table);
        $form->addElement('hidden','command','list');
        $form->addElement('text','keyword','');
        $form->addElement('submit','submit','');
        $form->setDefaults($_REQUEST);
        
        $renderer =& new HTML_QuickForm_Renderer_Default();
        $renderer->setFormTemplate("\n<form{attributes}>\n<table border=\"0\">\n\t<tr>\n\t\t<td align=\"right\" valign=\"middle\">\n{content}\n</td>\n\t</tr></table>\n</form>");
        $renderer->setElementTemplate("<!-- BEGIN required --><span style=\"color: #ff0000\">*</span><!-- END required --><b>{label}</b></td>\n\t\t<td valign=\"top\" align=\"left\"><!-- BEGIN error --><span style=\"color: #ff0000\">{error}</span><br /><!-- END error -->\t{element}");
        $form->accept($renderer);
        $contents .= '<div style="vertical-align: middle">'.$renderer->toHtml().'</div>';
        
        $navihtml = '<div class="pages">';
        if($this->page>0) {
            $navihtml .= sprintf('<a href="%s">&nbsp;</a> ',$this->getURL($this->prevpage));
        }
        else {
            $navihtml .= '&nbsp; ';
        }
        $navihtml .= ' | ';
        foreach($this->index as $i) {
            if($i==$this->page) {
                $navihtml .= sprintf('<span class="selected">%d</span> | ',($i/$this->atpage)+1);
            }
            else {
                $navihtml .= sprintf('<a href="%s">%d</a> | ',$this->getURL($i),($i/$this->atpage)+1);
            }
        }
        if($this->nextpage>0) {
            $navihtml .= sprintf(' <a href="%s">&nbsp;</a>',$this->getURL($this->nextpage));
        }
        else {
            $navihtml .= ' &nbsp;';
        }

        $navihtml .= '</div>';
        
        $contents .= $navihtml;
        $contents .= '<table class="list" cellpadding="0" cellspacing="0">';
        foreach($this->fields as $fieldname=>$label) {
            $lists[] = sprintf('<th class="list_header">%s</th>',htmlspecialchars($label)); 
        }
        $contents .= sprintf('<tr><th class="list_header">ޥ</th>%s</tr>',join("",$lists));
        $idx = 0;
        foreach($this->result as $r) {
            $lists = array();
            $cssclass = sprintf("center_column_message_%d",($idx%2)+1);
            
            foreach($this->fields as $fieldname=>$label) {
                $lists[] = sprintf('<td class="%s">%s</td>',$cssclass,htmlspecialchars($r->$fieldname)); 
            }
            $pkey = $this->pkey;
            $contents .= sprintf('<tr><td class="%s">[<a href="admin.php?table=%s&command=edit&%s=%s">Խ</a>]</td>%s</tr>',$cssclass,urlencode($this->table),urlencode($pkey),urlencode($r->$pkey),join("",$lists));
            ++$idx;
        }
        $contents .= '</table>';
        $contents .= $navihtml;
        $contents .= sprintf('<div class="indicator">%d - %d (%d)</div>',$this->page+1,$this->page+$idx,$this->result_num);

        $contents .= '</div>';
        
        return $contents;
    }
}
?>
