<?php

require_once 'DataObjects/Social_network_info.php';
require_once 'DataObjects/Person.php';
require_once 'PEAR.php';

define ( 'USERADD_RETURN_LINK', "<a href=\"admin.php?table=person&command=add\">桼Ͽ̤</a>" );

$forms['add']['person'] = 'UserAdd_Controller';

class UserAddForm extends YMForm {

    var $isvalidate = TRUE;

    function form() {

        //    add form element
        $this->addElement( 'text', 'account', '̾', array( 'size' => '45', 'maxlength' => '55' ) );
        $this->addElement( 'text', 'mail_address', '᡼륢ɥ쥹', array( 'size' => '45' ) );
        $name[] = $this->createElement( 'text', 'surname', '', array( 'size' => '20' ) );
        $name[] = $this->createElement( 'text', 'firstname', '̾', array( 'size' => '20' ) );
        $this->addGroup($name, 'name', '桼̾', null, false);
        $this->addGroupRule('name','桼̾̾ξϤƲ','required', null );
        $this->addElement( 'text', 'nick', '˥å͡', array( 'size' => '45' ) );
        $this->addElement( 'password', 'password', 'ѥ', array( 'size' => '45' ) );
        $this->addElement( 'password', 'password_confirm', 'ѥɤγǧ', array( 'size' => '45' ) );
        $this->addElement('hidden','command',$_REQUEST['command']);
        $this->addElement('hidden','table',$_REQUEST['table']);

        $this->addRule( 'account', '̾ϤƲ', 'required', null );
        $this->addRule( 'firstname', 'ϤƲ', 'minlength', null );
        $this->addRule( 'surname', '̾ϤƲ', 'required', null );
        $this->addRule( 'mail_address', '᡼륢ɥ쥹ϤƲ', 'required', null );
        $this->addRule( 'mail_address', '᡼륢ɥ쥹ϤƲ', 'email', null );
        $this->addRule( 'nick', '˥å͡ϤƲ', 'required', null );
        $this->addRule( 'password', 'ѥɤϤƲ', 'required', null );
        $this->addRule( 'password_confirm', 'ѥɤϤƲ', 'required', null );
        $this->addRule( 'password', 'ѥɤϣʸʾϤƲ', 'minlength', 6, null, 'server' );
        $this->addRule( array( 'password', 'password_confirm' ), 'ѥɤפޤ', 'compare', null, 'server' );

    }
    
    function action() {
        
        if( $this->isvalidate ) {
            if (!$this->validate()) return false;
            $this->freeze();
            return true;            
        }
        return true;
    }
}


class UserAdd_Controller extends YMForm_Controller {

    var $pagenum;

    function initialize() {
        $this->pagenum = 0;
        $this->forms = array("page1","page1_confirm");
    }

    function page1( $pagename ) {
        $form = new UserAddForm( $pagename );
        $form->button_action = 'ǧ';
        $this->pagenum = 1;
        return $form;
    }

    function page1_confirm($pagename) {
        $form = new UserAddForm( $pagename );
        $form->freeze();
        $form->button_action = 'Υ桼Ͽ';
        $form->button_prev = '';
        $form->isvalidate = FALSE;
        $this->pagenum = 2;
        return $form;
    }

    function action() {

        $this->pagenum = 3;
        
        //    get Submitted Value
        $values = $this->exportValues();
        $values = array_merge($values['page1']);

        //    add Person to database
        $person = new Person();
        $person->mail = $values['mail_address'];

        if( $person->find() > 0 ) {
             $str = "Υ桼ϴϿƤޤϾѹơ⤦ϿľƲ<P>";
             $str .= USERADD_RETURN_LINK;
             return $str;
        }

        $person->account = $values['account'];
        $person->nick = $values['nick'];
        $person->status = 'OK';
        $person->passwd = md5($values['password']);
        $person->surname = $values['surname'];
        $person->firstname = $values['firstname'];
        
        $person->insert();
 
        //    display registered result
        if( PEAR::isError( $person ) ) {
             $error_str = "桼Ͽ˥顼ȯޤ⤦ϿľƲ$person->getMessage()<P>";
             $error_str .= USERADD_RETURN_LINK;
             return $error_str;
        }

        return "桼ϿޤϿȤϡΥ󥯤򤿤ɤäϿƲ<P>".USERADD_RETURN_LINK;
        
    }

    function run() {

        $contents = parent::run();
        $title = 'User Information Register';
        if( $this->pagenum == 1 ) {
            $contents = "<h2 class='function'>$title</h2>桼ϿޤʲιܤϤơֳǧץܥ򲡤Ʋ<P>".$contents;
        } elseif ( $this->pagenum == 2 ) {
            $contents = "<h2 class='function'>$title</h2>ʲƤǤǤ С֤Υ桼Ͽץܥ򲡤Ʋ<P>".$contents;
        } else {
            $contents = "<h2 class='function'>$title</h2>".$contents;
        }
        return $contents;
    }
}

?>
