<?php
// $Id: command.php,v 1.2 2004/07/17 04:40:59 halt1983 Exp $
require_once 'DataObjects/Commandqueue.php';

class Command {
  var $_message, $queueid, $my;
  function execute() { return new CommandError(); }

  function save() {
    srand(time());
    $commandqueue = new Commandqueue();
    $commandqueue->key = substr(md5(rand()),0,16);
    $commandqueue->command = get_class($this);
    $commandqueue->serialized = serialize($this);
    $commandqueue->insert();
    $this->queueid = $commandqueue->id;
    return sprintf('%16s%d',$commandqueue->key,$commandqueue->id);
  }

  function get($queueid,$commandname=null) {
    $commandqueue = new Commandqueue();
    $result = $commandqueue->get(substr($queueid,16));
    if($result<1 || $commandqueue->key!=substr($queueid,0,16)) return null;
    if($commandname!=null && $commandqueue->command!=$commandname) return null;
    $filename = preg_replace('/command$/','',$commandqueue->command);
    if(preg_match('/[^a-zA-Z0-9]/',$filename)>0) return null; // for security
    require_once sprintf('commands/%s.php',$filename);
    return unserialize($commandqueue->serialized);
  }

  function delete($queueid,$commandname=null) {
    $commandqueue = new Commandqueue();
    $result = $commandqueue->get(substr($queueid,16));
    if($result<1 || $commandqueue->key!=substr($queueid,0,16)) return false;
    if($commandname!=null && $commandqueue->command!=$commandname) return false;
    $commandqueue->delete();
    return true;
  }
}

class CommandError {
  var $message, $type;

  function CommandError($message='unknow error',$type=NULL) {
    $this->message = $message;
    $this->type = $type;
  }
}

function is_error($obj) {
  return is_a($obj,'CommandError');  
}

?>
