<?php
// $Id: createcommunity.php,v 1.2 2004/07/17 04:40:59 halt1983 Exp $
require_once 'ymlib/ymmail.php';
require_once 'commands/command.php';
require_once 'DataObjects/Community.php';
require_once 'DataObjects/Community_bbs.php';
require_once 'commands/joincommunity.php';

class CreateCommunityCommand extends Command {
    var $community;
    var $name, $category, $explanation;
    var $joinrule;
    var $url, $rss, $xmlrpc;

    function execute() {
        $my = getMe();
        if($this->joinrule=='') $this->joinrule='open';
        if($this->category=='') $this->category='etc';

        $community = new Community();
        $community->owner = $my->account;
        $community->name = $this->name;
        $community->category = $this->category;
        $community->explanation = $this->explanation;
        $community->url = $this->url;
        $community->rss = $this->rss;
        $community->xmlrpc = $this->xmlrpc;
        $community->joinrule = $this->joinrule;
        $result = $community->insert();

        $community_bbs = new Community_Bbs();
        $community_bbs->id = $community->id;
        $community_bbs->title = $community->name;
        $community_bbs->create_person = $my->account;
        $community_bbs->rss_url = '/';
        $result = $community_bbs->insert();

        $community->url = sprintf("bbs.php?bbs_id=%d",$community_bbs->bbs_id);
        $community->update();
        
        $joincommunity = new JoinCommunityCommand();
        $joincommunity->communityid = $community->id;
        $result = $joincommunity->execute();
        return $result;
  }

}

?>
