<?php
/**
 * Basic Functions
 * @package wawawa
 * @version $Id: functions.php,v 1.2 2004/07/17 04:40:59 halt1983 Exp $
 */

require_once "DataObjects/Person.php";
require_once "DataObjects/Social_network_info.php";

/**
 * OC󋵂̃`FbN
 */
function check_login() {

    global $_my;
	
	$_my = NULL;

	if ( isset($_SESSION['my_account']) ) {
	    $_my = account2person($_SESSION['my_account']);
	}

	if( $_my == null ) {
        $_SESSION['login_backurl'] = ((getenv('SERVER_PORT')==443)?'https://':'http://').getenv('HTTP_HOST').getenv('REQUEST_URI');
        jump('login.php');
    }
    return $_my;
}

function check_url($url) {

    $url = trim($url);
    list($path,$params) = split("\\?",$url,2);

    if( $url == '' || strpos($path,'/') !== FALSE ) {
		return BASEURL;
	}

    return $url;

}

function set_sn_info() {
    $info = DB_DataObject::factory('Social_network_info');
    $info->fetch();
    define( 'SN_NAME', $info->name );
    define( 'SN_EXPLANATION', $info->explanation );
    define( 'SN_URL', $info->url );
    define( 'SN_RSS_URL', $info->rss_url );
    define( 'SN_ADMIN_MAIL', $info->admin_mail );
    return;
}


function clear_form() {
    unset($_SESSION['_form_container']);
}

function jump($pageName) {
    header(sprintf("Location: %s%s",BASEURL,$pageName));
    exit;
}

function getMe() {
    global $_my;
    if($_my==null) $_my = account2person($_SESSION['my_account']);
    return $_my;
}

if(!function_exists('http_build_query')) { 
    function http_build_query($params) {
        $a = array();
        foreach($params as $k=>$v) {
            array_push($a,urlencode($k).'='.urlencode($v));
        }
        return join('&',$a);
    }

 }


function display_contents($contents, $tplname = "frame.tpl" ) {
    if(PEAR::isError($contents)) {
        $contents = $contents->getMessage(); 
    }

    $smarty = YMForm_Controller::createSmarty();
    $smarty->assign('contents',$contents);
    $smarty->display( $tplname );
}

function smarty_a($array) {
    return array_merge($array, $_SESSION, array('baseurl'=>BASEURL));
}

function debuglog($str,$file='',$line='') {
    logging($str,PEAR_LOG_DEBUG,$file,$line);
}

function infolog($str,$file='',$line='') {
    logging($str,PEAR_LOG_INFO,$file,$line);
}

function errorlog($str,$file='',$line='') {
    logging($str,PEAR_LOG_ERR,$file,$line);
}

function warnlog($str,$file='',$line='') {
    logging($str,PEAR_LOG_WARNING,$file,$line);
}

function logging($str,$type,$file='',$line='') {
    global $_log;
    if($file != '') {
      $_log->log(sprintf("%s(%s): %s\n",$file,$line,$str),$type);
    }
    else {
        $_log->log($str,$type);
    }
}

function addMD5($str,$salt='tamanegioukoku') {
    return sprintf("%10s%05d%s",substr(md5($str),3,10),strlen($str),bin2hex($str));
}

function stripMD5($str,$salt='tamanegioukoku') {

	$md5 = substr($str,0,10);
	$l = substr($str,10,5)+0;
	$val = pack('H*',substr($str,15));

	if( substr(md5($val),3,10) != $md5 ) {
		return false;
	}

    return $val;

}
?>
