<?php
/**
 * ymdbdo
 * @package ymlib
 * @version $Id: ymdbdo.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
 */

require_once 'DB/DataObject.php';
require_once 'HTML/QuickForm.php';

class YMDB_DataObject extends DB_DataObject {

    var $_qf_elements = array(
        //  'account'=>array('text','account','',array('size' => 30, 'maxlength' => 255))
        );

    var $_qf_required = array(
        //  'account'=>'ȤɬܹܤǤ'
        );
    
    function &createFormElement(&$form,$field,$withrule=true) {
	
		$element_params = array(5);

        $method = sprintf("createFormElement_%s",$field);

		if(method_exists($this,$method)) {

			$element =& $this->$method($form);

		} else {

			if(array_key_exists($field,$this->_qf_elements)) {
				$element_params = $this->_qf_elements[$field];
			} else {
				$element_params = array('text',$field,$field,null,null);
            }

            $element =& $form->createElement(
				$element_params[0],
				$element_params[1],
				$element_params[2],
				$element_params[3],
				$element_params[4],
				$element_params[5]
			);

            $element->setPersistantFreeze(true);
        }
        if($withrule) {

            if(array_key_exists($field,$this->_qf_required)) {
                $form->addRule($field,$this->_qf_required[$field],'required',null);
            }
            $method = sprintf("addElementRule_%s",$field);
            if(method_exists($this,$method)) {
                $this->$method($form);
            }
        }
        return $element;
    }

    function &addFormElement(&$form,$field,$withrule=true) {
        $element =& $this->createFormElement($form,$field,$withrule);
        $element =& $form->addElement($element);
        return $element;
    }
    
}

?>