<?php
/**
 * ymlist
 * @package ymlib
 * @version $Id: ymlist.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
 */
class YMList_DataObject {
    var $script_name, $page, $atpage, $result, $result_num, $prevpage, $nextpage, $index;
    
    function YMList_DataObject() {
        $this->initialize();
    }
    
    function initialize() {
    }
    
    function run() {

        // ꥹȥå
		if ( isset($_REQUEST['page']) ) {
	        $this->page = $_REQUEST['page']+0;
		}
		
		if ( isset($_REQUEST['atpage']) ) {
	        $this->atpage = (($_REQUEST['atpage']<1)?(20):($_REQUEST['atpage']));
		}else{
			$this->atpage = 1;
		}
        
        $this->index = array();
        $dataobject =& $this->getDataObject();
        if(PEAR::isError($dataobject)) {
            $this->result_num = -1;
            $this->prevpage = $this->nextpage = $this->page = 0;
        }
        else {
            $this->result_num = $dataobject->count();
            $dataobject->limit($this->page,$this->atpage);
            $this->result = array();
            $rows = $dataobject->find();
            if($rows>0) {
                while($dataobject->fetch()) {
                    array_push($this->result,$dataobject);
                }
            }
            $this->prevpage = (($this->page-$this->atpage<0)?(0):($this->page-$this->atpage));
            $this->nextpage = (($this->page+$this->atpage>=$this->result_num)?(0):($this->page+$this->atpage));

            $thispage = $this->page/$this->atpage;
            $pages = $this->result_num/$this->atpage;
            for($i=(($thispage<5)?0:$thispage-5); $i<$pages; ++$i) {
                array_push($this->index,$i*$this->atpage);
            }
        }
        return $this->getContents();
    }

    function getDataObject() {
        return PEAR::raiseError('no data');
    }

    function getContents() {
        //$smarty = YMForm_Controller::createSmarty();
        //$smarty->assign_by_ref('list',$this);
        //return $smarty->fetch('**.tpl');
    }

    function getURL($page=null,$params=array()) {
        $params = array_merge($_GET,$_POST,$params);
        if($page!==null) $params['page'] = $page;
        return ($this->script_name==''?$_SERVER['SCRIPT_NAME']:$script_name).'?'.http_build_query($params);
    }

}



?>