<?php
/**
 * 
 * @package wawawa
 * @version $Id: admin.php,v 1.4 2004/07/17 08:11:37 halt1983 Exp $
 */
$forms = array();
require_once 'init.php';
require_once 'admin/person.php';
require_once 'admin/giveadminpriv.php';
require_once 'admin/baseregister.php';
require_once 'admin/useradd.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Community.php';
require_once 'DataObjects/Message.php';

$table = "";
$command = "";

// check if submitted user has priviliges
$my = check_login();
if( $my == NULL || $my->admin_flag == 'f' || $my->admin_flag == false ) {
    $_SESSION['login_backurl'] = ((getenv('SERVER_PORT')==443)?'https://':'http://').getenv('HTTP_HOST').getenv('REQUEST_URI');
    jump('login.php');
}

if ( isset($_REQUEST['table']) ) {
	$table = $_REQUEST['table'];
}

if ( isset($_REQUEST['command']) ) {
	$command = $_REQUEST['command'];
}

if ( ($command != "") && ($table != "") ) {
	$formclass = $forms[$command][$table];
}else{
	$formclass = NULL;
}

if( $formclass == NULL ) {
    $smarty = YMForm_Controller::createSmarty();
    $contents = $smarty->fetch('admin_top.tpl');
} else {
    $form = new $formclass();
    $contents = $form->run();
}

$smarty1 = YMForm_Controller::createSmarty();
$smarty1->assign( 'contents', $contents );
$status = new AdminStatistics();

if( $status->getError() ) {
    //  TODO: Error handling
    echo "error!";
}

$smarty1->assign( 'status', $status );
$smarty1->display( "admin_frame.tpl" );

/**
 * Admin˴ؤ򰷤饹
 */
class AdminStatistics {

    var $alluser_num;
    var $all_community_num;
    var $today_login_num;
    var $yesterday_login_num;
    var $today_regist_num;
    var $yesterday_regist_num;
    var $today_mes_num;
    var $yesterday_mes_num;
    var $error_messages = array();
    var $is_error = FALSE;    

    function AdminStatistics() {
        //    the number of All Member.
        $person = new Person();
	$this->alluser_num = $person->count();
        //    the number of All Community.
        $community = new Community();
        $this->all_community_num = $community->count();
        //    those who login today
        $person->whereAdd( "lastlogin between 'today' and 'tomorrow'" );
        $this->today_login_num = $person->count();
        //    those who login yesterday
        $person->whereAdd();              // clear the where condtion
        $person->whereAdd( "lastlogin between 'yesterday' and 'today'" );
        $this->yesterday_login_num = $person->count();
        //    those who regist today
        $person->whereAdd();              // clear the where condition
        $person->whereAdd( "createtime between 'today' and 'tomorrow'" );
        $this->today_regist_num = $person->count();
        //    those who regist yesterday
        $person->whereAdd();              // clear the where condition
        $person->whereAdd( "createtime between 'yesterday' and 'today'");
        $this->yesterday_regist_num = $person->count();
        //    Messages sent today.
        $message = new Message();
        $message->whereAdd( "sendtime between 'today' and 'tomorrow'" );
        $this->today_mes_num = $message->count();
        //    Messages sent yesterday.
        $message->whereAdd();             // clear the where condition
        $message->whereAdd( "sendtime between 'yesterday' and 'today'" );
        $this->yesterday_mes_num = $message->count();

        $this->setError( $person, $community, $message );

    }

    function setError( $person, $community, $message ) {

        if( PEAR::isError( $person ) ) {
            $this->is_error = TRUE;
            array_push( $this->error_messages, $person->getMessage() );
        }
        if( PEAR::isError( $community ) ) {
            $this->is_error = TRUE;
            array_push( $this->error_messages, $community->getMessage() );
        }
        if( PEAR::isError( $message ) ) {
            $this->is_error = TRUE;
            array_push( $this->error_messages, $message->getMessage() );
        }
    }

    function getError() {
        if( $this->is_error ) {
            return TRUE;
        }
        return FALSE;
    }

}
?>
