<?php
// $Id: CreateKeyword.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'forms/elements.php';
require_once 'commands/createkeyword.php';

function CreateKeywordForm_checkUnuseKeyword($keywordstr) {
  $keyword = new Keyword();
  $keyword->keyword = $keywordstr;

  if($keyword->count()==0) return true;
  return false;
}

class CreateKeywordForm extends YMForm {

  function form() {
    $this->addElement('header','first','create keyword');

    $this->addElement('text','keyword','');

    $this->addElement('select','category','ƥ꡼',Keyword::getCategorylabels());
    $this->addElement('textarea','comment','',array('cols' => 30, 'rows' => 5, 'maxlength' => 255));
  }

  function buildForm_page1() {
    $this->_formBuilt = true;
    $this->form();
    $this->setDefaultAction('next');
    $this->_submits["next"] = "ɤϿ";
  }

  function buildForm_page2() {
    $this->_formBuilt = true;
    $values = $this->controller->exportValues();
    $this->loadValues($values);
    $this->form();

    $this->setDefaultAction('submit');
    $this->_submits["back"] = "<<";
    $this->_submits["submit"] = "ɤϿ";
    $this->_freeze = TRUE;
  }
  
  function action($action, $actionName) {
    $values = $this->controller->exportValues();

    // ɴϢŤޥɤ¹
    $createkeyword_command = new CreateKeywordCommand();
    $createkeyword_command->my = getMe();
    $createkeyword_command->keyword = $values['keyword'];
    $createkeyword_command->comment = $values['comment'];
    $createkeyword_command->category = $values['category'];
    $result = $createkeyword_command->execute();

    jump('index.php');
  }
  
  function run() {
    $wizard =& YMForm::makeController("form");
    $wizard->addPage(new CreateKeywordForm('page1'));
    $wizard->addPage(new CreateKeywordForm('page2'));
    $wizard->run();
  }
  
}

?>
