<?php
// $Id: MakeFriendRequest.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Invitation.php';
require_once 'commands/invite.php';
require_once 'commands/sendmessage.php';

class MakeFriendRequestForm extends YMForm {

  function form() {
    $this->addElement('header','first','Message to friend');

    $this->addElement('hidden','with','ͧã');
    $this->addElement('select', 'relation', 'ط', Friend::getRelationLabels());
    $this->addElement('textarea','comment','å',array('cols' => 30, 'rows' => 5, 'maxlength' => 255));
  }
  
  function buildForm_page1() {
    //$this->_smarty_template = 'regist_form.tpl';
    $this->_formBuilt = true;
    $this->form();
    $this->setDefaultAction('submit');
    $this->_submits["submit"] = "ͧã˲ä";
    $this->_freeze = FALSE;
    clear_form();
  }

  function action($action, $actionName) {
    $my = getMe();
    $values = $this->controller->exportValues();
    $with = account2person($values['with']);

    // ͧãˤʤ륳ޥɤä
    $makefriend_command = new MakeFriendCommand();
    $makefriend_command->my = $my;
    $makefriend_command->with = $with;
    $makefriend_command->relation = $values['relation'];
    //$makefriend_command->execute(); 

    // MessageȤꤲ롣
    $message = new SendMessageCommand();
    $message->commandid = $makefriend_command->save();
    $message->receiver = $with;
    $message->subject = sprintf("%s %sͧãˤʤäߤä",$with->firstname,$with->surname);
    $message->body = "ͧãꥹȤ˲äƤǤ\n".$values['comment'];
    $message->execute();
    
    jump('index.php');
  }

  function run() {
    $wizard =& YMForm::makeController("form");
    $wizard->setDefaults(array_merge(array('with'=>$_REQUEST['account'])));
    $wizard->addPage(new Page1_MakeFriendRequestForm('page1'));
    $wizard->run();
  }
}

?>
