<?php
// $Id: invite.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Invitation.php';
require_once 'commands/invite.php';

class InviteForm extends YMForm {
    
    function form() {
        $this->addElement('header','first','Invite a friend');

        $invitation = new Invitation();
        $invitation->addFormElement($this,'mail');
        $name[] = $invitation->createFormElement($this,'surname',false);
        $name[] = $invitation->createFormElement($this,'firstname',false);        
        $this->addGroup($name, 'name', '̾', null, false);
        $this->addGroupRule('name','̾ϤƤ','required',null);
        $invitation->addFormElement($this,'comment');
    }
}

class InviteForm_Controller extends YMForm_Controller {
    
    function initialize() {
        $this->forms = array("page1","page1_confirm");
    }
      
    function page1($pagename) {
        $form = new InviteForm($pagename);
        $form->button_action = '';
        return $form;
    }

    function page1_confirm($pagename) {
        $form = new InviteForm($pagename);
        $form->freeze();
        $form->button_action = '';
        return $form;
    }
    
    function action() {
        $my = getMe();
        
        $values = $this->exportValues();
        $values = $values['page1'];
        $invite_command = new InviteCommand();
        $invite_command->my = $my;
        $invite_command->invite_from = $my->account;
        $invite_command->mail = $values['mail'];
        $invite_command->firstname = $values['firstname'];
        $invite_command->surname = $values['surname'];
        $invite_command->comment = $values['comment'];
        $invitation = $invite_command->execute();
        if(PEAR::isError($invitation)) return $invitation;

        $smarty = $this->createSmarty();
        $smarty->assign('id',$invitation->id);
        return $smarty->fetch('finish_invite.tpl');
    }
}

// եμ¹
check_login();
$form = new InviteForm_Controller();
display_contents($form->run());
?>
