<?php
// $Id: join.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Invitation.php';
require_once 'commands/join.php';

class PersonForm extends YMForm {
  
  function form() {
    $this->addElement('header','first','Basic infomation');
    $this->addElement('hidden','vid');
    
    $person = new Person();
    $person->addFormElement($this,'mail');
    $person->addFormElement($this,'passwd');
    $name[] = $person->createFormElement($this,'surname',false);
    $name[] = $person->createFormElement($this,'firstname',false);
    $this->addGroup($name, 'name', '̾', null, false);
    $this->addGroupRule('name','̾ϤƤ','required',null);
    $person->addFormElement($this,'nick');
  }

}

class JoinForm_Controller extends YMForm_Controller {
    function initialize() {
        $this->forms = array("page1","page1_confirm");
    }
    
    function hookMakedForm(&$form) {
        $form->setDefaults($_REQUEST);
        $invitation = Invitation::getFromVID($_REQUEST['vid']);
        if($invitation==null) {
            return PEAR::raiseError("ξԾ̵Ǥ");
        }
        $form->setDefaults(array('firstname'=>$invitation->firstname,'surname'=>$invitation->surname,'mail'=>$invitation->mail));
        return TRUE;
    }

    // ܾ
    function page1($pagename) {
        $form = new PersonForm($pagename);
        $form->button_action = 'next >>';
        return $form;
    }
    
    function page1_confirm($pagename) {
        $form = new PersonForm($pagename);
        $form->freeze();
        $form->button_action = 'next >>';
        $form->button_prev = '<< prev';
        return $form;
    }
    
    // ץ¹
    function action() {
        $values = $this->exportValues();
        $values = array_merge($values['page1']);

        // 桼Ͽ
        $join_command = new JoinCommand();
        $join_command->my = getMe();
        $join_command->invitation_id = $values['vid'];
        $join_command->values = $values;
        $person = $join_command->execute();
        if(PEAR::isError($person)) {
            return $person;
        }
        
        // Ͽλ̤Ф
        $smarty = $this->createSmarty();
        $smarty->assign('id',$person->id);
        return $smarty->fetch(($join_command->status=='OK')?'registed1.tpl':'registed2.tpl');
    }
}

// եμ¹
$form = new JoinForm_Controller();
$contents = $form->run();
if(PEAR::isError($contents)) {
    echo $contents->getMessage(); 
 }
 else {
     echo $contents;
 }

?>
