<?php

function resizeJPEG($sourcefile, $destfile, $width, $height) {
    list($sx, $sy, $type, $attr) = getimagesize($sourcefile);
    $src = false;
    if($type==1) {
        $src = ImageCreateFromGIF($sourcefile);
    }
    elseif($type==2) {
        $src = ImageCreateFromJPEG($sourcefile);
    }
    if(!$src) return false;

    $_x_zoom = ($width/$sx);
    $_y_zoom = ($height/$sy);
    $_x = $_y= 0;
    if($_x_zoom<$_y_zoom) {
        $_sx = ($width/$height)*$sy;
        $_sy = $sy;
        $_x = ($sx-$_sx)/2;
    }
    else {
        $_sy = ($height/$width)*$sx;
        $_sx = $sx;
        $_y = ($sy-$_sy)/2;
    }
    
    $dst = ImageCreateTrueColor($width,$height);
    ImageCopyResampled($dst, $src,0,0,$_x,$_y,$width,$height,$_sx,$_sy);
    if(!ImageJPEG($dst,$destfile)) return false;
    return true;
}

function YMFormRule_isImage($file) {
    list($width, $height, $type, $attr) = getimagesize($file['tmp_name']);
    if($type==1 || $type==2) return true;
    return false;
}


?>