<?php
// $Id: sendmessage.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Message.php';
require_once 'commands/sendmessage.php';

class SendMessageForm extends YMForm {
    function form() {
        $this->registerElementType('account','forms/elements.php','HTML_QuickForm_account');
        
        $this->addElement('header','first','message to friend');
        $this->addElement('hidden','commandid');
        $this->addElement('hidden','id');
        
        $this->addElement('account','receiver','');
        $this->addElement('account','sender','п');
        $this->addElement('text','subject','ȥ',array('size' => 30, 'maxlength' => 255));
        $this->addElement('textarea','body','å',array('cols' => 30, 'rows' => 5, 'maxlength' => 255));
    }
}

class SendMessageForm_Controller extends YMForm_Controller {
    function initialize() {
        $this->forms = array("page1","page1_confirm");
    }

    function hookMakedForm(&$form) {
        $my = getMe();
        $form->setDefaults(array('receiver'=>$_REQUEST['receiver'],'sender'=>$my->account));
        return true;
    }
    
    // ܾ
    function page1($pagename) {
        $form = new SendMessageForm($pagename);
        $form->button_action = 'confirm >>';
        return $form;
    }
    
    function page1_confirm($pagename) {
        $form = new SendMessageForm($pagename);
        $form->freeze();
        $form->button_action = 'send >>';
        $form->button_prev = '<< prev';
        return $form;
    }
    
    // ץ¹
    function action() {
        $values = $this->exportValues();
        $values = array_merge($values['page1']);
        $receiver = account2person($values['receiver']);
        $my = getMe();

        // åޥɤ¹
        $sendmessage_command = new SendMessageCommand();
        $sendmessage_command->commandid = null;
        $sendmessage_command->my = $my->account;
        $sendmessage_command->receiver = $receiver->account; 
        $sendmessage_command->subject = $values['subject'];
        $sendmessage_command->body = $values['body'];
        $sendmessage_command->execute();
        
        jump('index.php');
    }
}


check_login();
$form = new SendMessageForm_Controller();
$contents = $form->run();
display_contents($contents);
?>
