<?php
/**
 * Table Definition for invitation
 */
require_once 'DB/DataObject.php';

class Invitation extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'invitation';                      // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.invitation_id_seq%29 primary_key
    var $createtime;                      // timestamp(8)  default_now%28%29
    var $invited;                         // bool(1)  not_null default_false
    var $invite_from;                     // text(-1)  
    var $firstname;                       // text(-1)  
    var $surname;                         // text(-1)  
    var $mail;                            // text(-1)  not_null

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Invitation',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function getFromVID($vidstr) {
      $vid = stripMD5($vidstr);
      if($vid==false) return null;
      $invitation = new Invitation();
      $rows = $invitation->get($vid);
      if($rows==0 || $invitation->invited=='t') return null;
      return $invitation;
    }

    var $formelements = array(
     'account'=>array('text','account','',array('size' => 30, 'maxlength' => 255)),
     'mail'=>array('text','mail','᡼륢ɥ쥹',array('size' => 30, 'maxlength' => 255)),
     'passwd'=>array('password','passwd','ѥ',array('size' => 20, 'maxlength' => 32)),
     'surname'=>array('text', 'surname', '', array('size' => 8, 'maxlength' => 63)),
     'firstname'=>array('text', 'firstname', '̾', array('size' => 10, 'maxlength' => 63)),
     'nick'=>array('text','nick','˥å͡',array('size' => 30, 'maxlength' => 63)),
     'comment'=>array('textarea','comment','',array('cols' => 40, 'rows' => 6, 'maxlength' => 512))
     );

    function &createFormElement(&$form,$field,$withrule=true) {
        if(!array_key_exists($field,$this->formelements)) return PEAR::raiseError('field not found in Person::addFormElement()');

        $element_params = $this->formelements[$field];
        $element =& $form->createElement($element_params[0],$element_params[1],$element_params[2],$element_params[3]);
        return $element;
    }
         
    function &addFormElement(&$form,$field,$withrule=true) {
        if(!array_key_exists($field,$this->formelements)) return PEAR::raiseError('field not found in Person::addFormElement()');

        $element_params = $this->formelements[$field];
        $element =& $form->addElement($element_params[0],$element_params[1],$element_params[2],$element_params[3]);
        if(PEAR::isError($element))  return PEAR::raiseError('field not found in Person::addFormElement()');
        $element->setPersistantFreeze(true);
        if($withrule) {
            switch($field) {
            case 'mail':
                $form->addRule('mail','᡼륢ɥ쥹ϤƤ','required',null);
                $form->addRule('mail','᡼륢ɥ쥹ϤƤ','email');
                $form->registerRule('checkMail', 'callback', 'PersonForm_checkUnuseMail');
                $form->addRule('mail','Υ᡼륢ɥ쥹ϤǤ˻ѤƤޤ','checkMail');
                break;
                
            case 'surname':
                $form->addRule('surname','̾()ϤƤ','required',null);
                break;
                
            case 'firstname':
                $form->addRule('firstname','̾(̾)ϤƤ','required',null);
                break;
                
            }
        }
        return $element;
    }

}
?>