<?php
/**
 * Table Definition for keyword
 */
require_once 'DB/DataObject.php';

class Keyword extends DB_DataObject 
{
    ###START_AUTOCODE
    /* the code below is auto generated do not remove the above tag */

    var $__table = 'keyword';                         // table name
    var $id;                              // int4(4)  not_null default_nextval%28public.keyword_id_seq%29 primary_key
    var $createtime;                      // timestamp(8)  default_now%28%29
    var $creator;                         // text(-1)  
    var $keyword;                         // text(-1)  unique_key
    var $comment;                         // text(-1)  
    var $category;                        // text(-1)  

    /* ZE2 compatibility trick*/
    function __clone() { return $this;}

    /* Static get */
    function staticGet($k,$v=NULL) { return DB_DataObject::staticGet('Keyword',$k,$v); }

    /* the code above is auto generated do not remove the tag below */
    ###END_AUTOCODE

    function categoryLabel() {
      $labels = $this->getCategoryLabels();
      $label = $labels[$this->category];
      return(($label=='')?($this->category):($label));
    }

    function getCategoryLabels() {
      return array('book'=>"֥å",'goods'=>"å",'foods'=>"ա",'entertainment'=>"󥿡ƥ",'music'=>"ߥ塼å",'sport'=>"ݡ",'leisure'=>"쥸㡼",'computer'=>"ԥ塼",'art'=>"",'noncategory'=>"Υ󥫥ƥ",'homepage'=>"ۡڡ");
    }

}

function keywordid2keyword($id) {
  $keyword = new Keyword();
  if($keyword->get($id)<1)
    return null;
  return $keyword;
}


?>