<?php
//require_once 'init.php';
require_once 'commands/listfriends.php';

class FriendListApplet {
    
    function execute($params) {
        $contents = '';
        $listfriend = new ListFriendsCommand();
        $owner = $params['owner'];
        if(is_a($owner,'Person')) $owner = $owner->account;
        if($owner!='') $listfriend->owner = $owner;
        $listfriend->execute();
        foreach($listfriend->friends as $friend) {
            $comment = '';
            if($owner!='' && $friend->isFriend()) {
                $comment .='̤ͧã ';
            }
            $nameformat = $params['name'];
            switch($nameformat) {
            case 'name':
                $name = sprintf('%s %s',htmlspecialchars($friend->firstname),htmlspecialchars($friend->surname));
                break;

            case 'nick':
                $name = htmlspecialchars($nick);
                break;

            case 'withnick':
            default:
                $name = sprintf('%s %s(%s)',htmlspecialchars($friend->firstname),htmlspecialchars($friend->surname),htmlspecialchars($friend->nick));
            }
            
            $url = $params['url'];
            if($url=='') $url = 'person.php?id=%s';
            
            $contents .= sprintf("<a href=\"$url\">%s</a>",urlencode($friend->account),$name);
            $mail = strtolower($params['mail']);
            if($mail=='t'||$mail=='true') $contents .= sprintf('&nbsp;[<a href="sendmessage.php?receiver=%s">M</a>]',urlencode($friend->account));

            $contents .= htmlspecialchars($comment)."<br />\n";
        }
        return $contents;
    }

}


?>
