<?php

//require_once 'init.php';
require_once 'DataObjects/Person.php';

class RecentPersonListApplet {

    function execute( $params ) {

        $display_num = $params['num'];
        $recent_span = $params['span'];

        $person = new Person();
        $person->whereAdd( "createtime between current_date - $recent_span and 'tomorrow'");
        
        //    no Person who registered in last XX days is found
        //    display "No Person"
        if( $person->find() == 0 ) {
            return "<div class='news_contents_1'>Ƕ".$recent_span."֤ϿͤϤޤ</div>";
        }
        
        $returnList = '';
        $counter = 0;
        
        while( $person->fetch() ) {
            $tmp = $counter + 1;
            
            if( $tmp % 2 == 1 ) {
                $returnList .= "<div class='news_contents_1'>".$person->nick."</div>";
            }
            else {
                $returnList .= "<div class='news_contents_2'>".$person->nick."</div>";
            }
            
            if( $tmp == $display_num ) {
                break;
            }
            $counter++;
        }
        
        if( PEAR::isError( $person ) ) {
            return "<div class='news_contents_1'>桼˥顼ȯޤ</div>";
        }
        
        return $returnList;
    }

}

?>
