<?php
// ڡΤ˻Ȥ饤֥ɤ߹
require_once 'HTML/QuickForm.php';
require_once 'HTML/QuickForm/Renderer/ArraySmarty.php';
require_once 'Smarty/Smarty.class.php';

class newYMForm extends HTML_QuickForm {
    var $button_submit, $button_next, $button_prev;
    var $smarty_template, $template_values;
    var $_form_messages = array('error_required'=>"%sɬܹܤǤ");

    function newYMForm($formName, $method='post', $action='', $target='_self', $attributes=null, $trackSubmit = false) {
        $this->HTML_QuickForm($formName, $method, $action, $target, $attributes, $trackSubmit);
        $this->_initialize();
    }
    
	/**
	 * _initialize
	 * @abstract
	 */
    function _initialize() {
        // 
    }

	/**
	 * _elements
	 * @abstract
	 */
    function _elements() {
        // $this->addElement('submit','command_action','submit');
    }

	/**
	 * Add FormElement
	 */
	function addElements() {
	
        $element =& $this->addElement('hidden','__ymform_name');
        $element->setValue($this->getAttribute('name'));
        $this->_elements();
        if(is_string($this->button_submit))
            $this->addElement('submit','__command_submit',$this->button_submit);
        if(is_string($this->button_next))
            $this->addElement('submit','__command_next',$this->button_next);
        if(is_string($this->button_prev))
            $this->addElement('submit','__command_prev',$this->button_prev);
    }
    
    function getHTML() {
        if(!is_array($this->template_values)) $this->template_values=array();
        
        if(is_string($this->smarty_template) && $this->smarty_template!='') {
            $smarty = YMForm_Controller::createSmarty();
            $renderer =& new HTML_QuickForm_Renderer_ArraySmarty($smarty);
            $this->accept($renderer);
            foreach($this->template_values as $k=>$v) {
                $smarty->assign_by_ref($k,$v);
            }
            $smarty->assign('form',$renderer->toArray());
            return $smarty->fetch($this->smarty_template);
        }
        else {
            $renderer =& $this->defaultRenderer();
            $this->setRequiredNote(sprintf($this->_form_messages['error_required'],'<span class="form_required">*</span>'));
            $this->setJsWarnings('Those fields have errors :', 'Thanks for correcting them.');
            
            $renderer->setFormTemplate('<table width="450" border="0" cellpadding="3" cellspacing="2" class="form_table"><form{attributes}>{content}</form></table>');
            $renderer->setHeaderTemplate('<tr><td  class="form_table_header" colspan="2"><b>{header}</b></td></tr>');
            $renderer->setGroupTemplate('<table><tr>{content}</tr></table>');
            $renderer->setGroupElementTemplate('<td>{element}<br /><span style="font-size:10px;"><span class="form_required"">*</span>{label}</span></td>');
            
            $this->accept($renderer);
            return $renderer->toHtml();
        }
    }
}

/*
// {applet name="XXXX"}applet/XXXX.phpɤ߹(new XXXXApplet())->execute()¹
function ymform_controller_applet($params) {
    $name = $params['name'];
    if(preg_match('/[^a-zA-Z0-9]/',$name)>0) return ""; // for security
    require_once("applet/".strtolower($name).".php");
    $appletname = $name."Applet";
    $applet = new $appletname();
    return $applet->execute($params);
}
*/

class newYMForm_Controller {
    var $_pageflow; // = array("page1","page1_confirm","page2");
    
    function newYMForm_Controller() {
        $this->_initialize();
    }
    
    function _initialize() {
    }
    
    // set default datas
    function _setDefaults(&$form) {
    }

    // action of pushed 'submit button' or pushed 'next button' of last page
    function _action_submit() {
        return "done.";
    }
    
    // default action is save params and go to next page
    function &_action_next() {
        $method = sprintf("_action_next_%s",$this->_thispage);
        if(method_exists($this,$method)) {
            $form =& $this->$method();
            if(method_exists($form,'getHTML')) {
                return $form;
            }
            elseif($form===false) {
                $form =& $this->_createFormObject($this->_thispage);
                return $form;
            }
        }
        $nextpage = $this->_getNextPagename();
        $form =& $this->_createFormObject($nextpage);
        return $form;
    }

    // pushed next button of page1
    //function &_action_next_page1() {
    //    return YMForm object || true || false
    //    true: move to next page
    //    false: don't move
    //}
    
    // service funtion
    function createSmarty() {
        // Smartyν
        $smarty = new Smarty;
        $smarty->template_dir = "./templates";
        $smarty->compile_dir = "./templates_c";
        $smarty->cache_dir = "./cache";
        $smarty->register_function('applet','ymform_controller_applet');
        $smarty->assign('my',getMe());
        return $smarty;
    }

    function _getPrevPagename() {
        $prevpage_id = array_search($this->_thispage,$this->_pageflow)-1;
        if($prevpage_id<0) return $this->_pageflow[0];
        return $this->_pageflow[$prevpage_id];
    }

    function _getNextPagename() {
        $nextpage_id = array_search($this->_thispage,$this->_pageflow)+1;
        if($nextpage_id>=count($this->_pageflow)) return null;
        return $this->_pageflow[$nextpage_id];
    }
    
    function run() {
        if(array_key_exists('__ymform_name',$_REQUEST)) {
            $this->_thispage = $_REQUEST['__ymform_name'];
        }
        else {
            $this->_thispage = $this->_pageflow[0];
            $form =& $this->_createFormObject($this->_thispage);
            $this->_setDefaults($form);
            return $form->getHTML();
        }
        // push 'prev'
        if(array_key_exists('__command_prev',$_REQUEST)) {
            $prevpage = $this->_getPrevPagename();
            $form =& $this->_createFormObject($prevpage);
            if(PEAR::isError($form)) return $form;
        }
        // push 'next' or 'submit'
        else {
            $form =& $this->_createFormObject($this->_thispage);        
            if(PEAR::isError($form)) return $form;

            // save page params
            $values = $this->exportValues();
            $formvalues = $form->exportValues();
            foreach($formvalues as $k => $v) {
                if(substr($k,0,2)!='__')
                    $values[$k] = $v;
            }
            $encodedvalues = array();
            foreach($values as $k => $v) {
                $encodedvalues[] = urlencode($k).'='.urlencode($v);
            }
            $_REQUEST['__ymform_values'] = join(',',$encodedvalues);

            if($form->validate()) {
                $lastpage = $this->_thispage;
                $nextpage = $this->_getNextPagename();
                if(array_key_exists('__command_submit',$_REQUEST) || $nextpage==null)
                    $form =& $this->_action_submit();
                else
                    $form =& $this->_action_next();
            }
        }
        if(method_exists($form,'getHTML'))
            return $form->getHTML();

        return $form;
    }

	function _createFormObject($pagename) {

		if ( isset($_REQUEST['__ymform_values']) ) {
			$ymform_values = $_REQUEST['__ymform_values'];
		}else{
			$ymform_values = NULL;
		}

		$method = sprintf("_createFormObject_%s",$pagename);

		$form =& $this->$method($pagename);
		$element =& $form->addElement('hidden','__ymform_values');
		$element->setValue($ymform_values);
        return $form;
    }
    
    function exportValues() {

        $values = array();
		$key = "";
		$value = "";
		

        foreach(split(',',$_REQUEST['__ymform_values']) as $line) {

			@list($key,$value) = split('=',$line,2);
			$values[urldecode($key)] = urldecode($value);

        }

        return $values;

    }
}

?>