<?php
// $Id: editprofile.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'ymlib/newymctrl.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Invitation.php';
require_once 'commands/join.php';

class PersonForm extends newYMForm {
    function _elements() {
        $this->addElement('header','first','Basic infomation');
        $this->addElement('hidden','vid');

        $person = new Person();
        $person->addFormElement($this,'mail');
        $person->addFormElement($this,'passwd');
        $name[] = $person->createFormElement($this,'surname',false);
        $name[] = $person->createFormElement($this,'firstname',false);
        $this->addGroup($name, 'name', '̾', null, false);
        $this->addGroupRule('name','̾ϤƤ','required',null);
        $person->addFormElement($this,'nick');
        $person->addFormElement($this,'birthday');
        $person->addFormElement($this,'birthplace');
        $person->addFormElement($this,'presentaddress');
        $person->addFormElement($this,'occupation');
        $person->addFormElement($this,'hobby');
        $person->addFormElement($this,'comment');
        $person->addFormElement($this,'imessenger');
        $person->addFormElement($this,'website');
        $person->addFormElement($this,'lastwork');
        $person->addFormElement($this,'lastbuy');
        $person->addFormElement($this,'rss');
    }
}

class JoinForm_Controller extends newYMForm_Controller {
    var $_fields = array('mail','passwd','firstname','surname','nick','lastbuy','birthday','birthplace','presentaddress','occupation','hobby','comment','imessenger','website','lastwork','rss');
    
    function _initialize() {
        $this->_pageflow = array("page1","page1_confirm");
    }
    
    function _setDefaults(&$form) {
        $my = getMe();
        $data = array();
        foreach($this->_fields as $field) {
            $data[$field] = $my->$field;
        }
        $form->setDefaults($data);
        return TRUE;
    }
    
    // ܾ
    function &_createFormObject_page1($pagename) {
        $form = new PersonForm($pagename);
        $form->smarty_template = 'editprofile.tpl';
        $form->button_next = 'next >>';
        $form->addElements();
        return $form;
    }
    
    function &_createFormObject_page1_confirm($pagename) {
        $form = new PersonForm($pagename);
        $form->freeze();
        $form->button_next = 'next >>';
        $form->button_prev = '<< prev';
        $form->addElements();
        return $form;
    }
    
    // ץ¹
    function _action_submit() {
        $values = $this->exportValues();
        $my = getMe();
        $profile = new Person();
        $profile->get($my->account);
        foreach($this->_fields as $field) {
            $profile->$field = $values[$field];
        }
        $profile->update();
        jump('index.php');
    }
    
}

// եμ¹
check_login();
$form = new JoinForm_Controller();
display_contents($form->run());
?>
