<?php
// $Id: makefriend.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Message.php';
require_once 'commands/makefriend.php';
require_once 'commands/sendmessage.php';

class MakeFriendRequestForm extends YMForm {

    function form() {
        $this->addElement('header','first','Message to friend');
        
        $this->addElement('hidden','with','ͧã');
        $this->addElement('select', 'relation', 'ط', Friend::getRelationLabels());
        $this->addElement('textarea','comment','å',array('cols' => 30, 'rows' => 5, 'maxlength' => 255));
    }
    
}

class MakeFriendRequestForm_Controller extends YMForm_Controller {
    function initialize() {
        $this->forms = array("page1","page1_confirm");
    }
    
    function page1($pagename) {
        $form = new MakeFriendRequestForm($pagename);
        $form->button_action = 'next >>';
        return $form;
    }
    
    function page1_confirm($pagename) {
        $form = new MakeFriendRequestForm($pagename);
        $form->freeze();
        $form->button_action = 'next >>';
        $form->button_prev = '<< prev';
        return $form;
    }
    
    function hookMakedForm(&$form) {
        $form->setDefaults($_REQUEST);
    }

    // ץ¹
    function action() {
        $values = $this->exportValues();
        $values = array_merge($values['page1']);
        $my = getMe();
        $with = account2person($values['with']);

        // ͧãˤʤ륳ޥɤä
        $makefriend_command = new MakeFriendCommand();
        $makefriend_command->my = $my->account;
        $makefriend_command->with = $with->account;
        $makefriend_command->relation = $values['relation'];
        
        // MessageȤꤲ롣
        $message = new SendMessageCommand();
        $message->commandid = $makefriend_command->save();
        $message->receiver = $with->account;
        $message->subject = sprintf("%s %sͧãˤʤäߤä",$my->firstname,$my->surname);
        $message->body = "ͧãꥹȤ˲äƤǤ\n----\n".$values['comment'];
        $message->execute();
    
        jump('index.php');
    }
}

// եμ¹
$form = new MakeFriendRequestForm_Controller();
display_contents($form->run());

?>
