<?php
/**
 * MessageList
 * @package wawawa
 * @version $Id: messagelist.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
 */

require_once 'init.php';
require_once 'DataObjects/Person.php';
require_once 'DataObjects/Message.php';
require_once 'commands/deletemessage.php';
require_once 'ymlib/ymlist.php';

check_login();

class MessageListView extends YMList_DataObject {
  
    function initialize() {
        $this->script_name = 'messagelist.php';
    }
  
    function getDataObject() {
        $my = getME();
        $message = new Message();
        $message->receiver = $my->account;
        return $message;
    }

    function getContents() {
        $smarty = YMForm_Controller::createSmarty();
        $smarty->assign_by_ref('list',$this);
        return $smarty->fetch('messagelist.tpl');
    }

    function getURL_Command($page,$command,$messageid) {
        return $this->getURL($page,array('command'=>$command,'messageid'=>$messageid));
    }
    
}

if ( isset($_REQUEST['command']) ) {
	$command = $_REQUEST['command'];
}else{
	$command = '';
}

switch ($command) {

case 'delete':
	$deletecommand = new DeleteMessageCommand();
	$deletecommand->messageid = $_REQUEST['messageid'];
	$deletecommand->execute();
	break;

}

$list = new MessageListView();
display_contents($list->run());

?>
