<?php
// $Id: uploadphoto.php,v 1.2 2004/07/17 04:41:00 halt1983 Exp $
require_once 'init.php';
require_once 'ymlib/newymctrl.php';
require_once 'libphoto.php';

class UploadPhotoForm extends newYMForm {
    function _initialize() {
        $this->smarty_template = 'uploadphoto.tpl';
    }

    function _elements() {
        $this->addElement('file','photo','ե(jpeg)');
        $this->addRule('photo','jpeg fileꤷƤ','required',null);
        $this->registerRule('isImage', 'callback', 'YMFormRule_IsImage');
        $this->addRule('photo','JPEGGIFե򤷤Ƥ','isImage');
    }
}

class UploadPhotoConfirmForm extends newYMForm {
    function _initialize() {
        $this->smarty_template = 'uploadphoto_confirm.tpl';
    }
}

class UploadPhotoForm_Controller extends newYMForm_Controller {
    function _initialize() {
        $this->_pageflow = array("page1","page1_confirm");
    }
    
    // ܾ
    function &_createFormObject_page1($pagename) {
        $form = new UploadPhotoForm($pagename);
        $form->button_next = 'åץ >>';
        $form->addElements();
        return $form;
    }
    
    function &_createFormObject_page1_confirm($pagename) {
        $form = new UploadPhotoConfirmForm($pagename);
        $form->button_next = 'åץ >>';
        $form->button_prev = '<< '; 
        $form->addElements();
        return $form;
    }

    function _action_next_page1() {
        $my = getMe();
        $dirname = sprintf("photos/%s",$my->account);
        if(!file_exists($dirname)) {
            mkdir($dirname,0755);
            if(!file_exists($dirname)) return null;
        }
        return resizeJPEG($_FILES['photo']['tmp_name'], sprintf("%s/__uploadtmp.jpg",$dirname), 144, 144);
    }
    
    // ץ¹
    function _action_submit() {
        $my = getMe();
        
        $dirname = sprintf("photos/%s",$my->account);
        if(!file_exists($dirname)) {
            mkdir($dirname,0600);
            if(!file_exists($dirname)) return null;
        }
        $uploadfile = sprintf("%s/__uploadtmp.jpg",$dirname);
        $filename = sprintf("%s/top.jpg",$dirname);
        if(copy($uploadfile,$filename)) {
            unlink($uploadfile);
        }
        jump("index.php");
    }
}

check_login();

// եμ¹
$form = new UploadPhotoForm_Controller();
display_contents($form->run());
?>
